package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.annotation.JsonBackReference;
import javax.persistence.ManyToOne;
import javax.validation.constraints.NotNull;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiPianificFerieKey;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePfKey;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_PIANIFIC_FERIE_AMMTO")
public class DpianificFerieAmmto extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 2866408319L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DpianificFerieAmmto.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_D_PIANIFIC_FERIE_AMMTO", columnDefinition = "NUMBER(15)")
	private Long sequIdDpianificFerieAmmto;
	@NotNull

	@Column(name = "CODI_PIANIFICAZIONE_FERIE", columnDefinition = "VARCHAR(50)")
	private String codiPianificazioneFerie;
	@NotNull

	@Column(name = "DESC_PIANIFICAZIONE_FERIE", columnDefinition = "VARCHAR(250)")
	private String descPianificazioneFerie;
	@NotNull

	@Column(name = "FK_ESITO_RICH_ADESIONE_PF", columnDefinition = "NUMBER(15)")
	private Long fkEsitoRichAdesionePf;
	@NotNull

	@Column(name = "FK_STATO_PIANIFIC_FERIE", columnDefinition = "NUMBER(15)")
	private Long fkStatoPianificFerie;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DpianificFerieAmmto(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DpianificFerieAmmto(DpianificFerieAmmtoKey dpianificFerieAmmtoKey, Long sequIdDpianificFerieAmmto,
			String codiPianificazioneFerie, String descPianificazioneFerie, Long fkEsitoRichAdesionePf,
			Long fkStatoPianificFerie, String flagEliminato, String utenteUltimaModifica, Date dataUltimaModifica,
			Date dataInizioRecord, Date dataFineRecord) {
		super();

		this.dpianificFerieAmmtoKey = dpianificFerieAmmtoKey;

		this.sequIdDpianificFerieAmmto = sequIdDpianificFerieAmmto;
		this.codiPianificazioneFerie = codiPianificazioneFerie;
		this.descPianificazioneFerie = descPianificazioneFerie;
		this.fkEsitoRichAdesionePf = fkEsitoRichAdesionePf;
		this.fkStatoPianificFerie = fkStatoPianificFerie;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDpianificFerieAmmto")
	@OneToMany(mappedBy = "theDpianificFerieAmmto", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DrichPianifFerieAmmto> theDrichPianifFerieAmmto = new ArrayList<>();

	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDpianificFerieAmmto")
	@OneToMany(mappedBy = "theDpianificFerieAmmto", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DperiodiAmmtoPf> theDperiodiAmmtoPf = new ArrayList<>();

	// PARENTS
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonBackReference("theDstatiPianificFerie")
	@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" }, allowSetters = true)
	private DstatiPianificFerie theDstatiPianificFerie;
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonBackReference("theDesitiRichAdesionePf")
	@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" }, allowSetters = true)
	private DesitiRichAdesionePf theDesitiRichAdesionePf;

	// GETTER/SETTER
	/**
	 * @return the sequIdDpianificFerieAmmto
	 */
	public Long getSequIdDpianificFerieAmmto() {
		return this.sequIdDpianificFerieAmmto;
	}

	/**
	 * @param sequIdDpianificFerieAmmto to set
	 */
	public void setSequIdDpianificFerieAmmto(Long sequIdDpianificFerieAmmto) {
		this.sequIdDpianificFerieAmmto = sequIdDpianificFerieAmmto;
	}

	/**
	 * @return the codiPianificazioneFerie
	 */
	public String getCodiPianificazioneFerie() {
		return this.codiPianificazioneFerie;
	}

	/**
	 * @param codiPianificazioneFerie to set
	 */
	public void setCodiPianificazioneFerie(String codiPianificazioneFerie) {
		this.codiPianificazioneFerie = codiPianificazioneFerie;
	}

	/**
	 * @return the descPianificazioneFerie
	 */
	public String getDescPianificazioneFerie() {
		return this.descPianificazioneFerie;
	}

	/**
	 * @param descPianificazioneFerie to set
	 */
	public void setDescPianificazioneFerie(String descPianificazioneFerie) {
		this.descPianificazioneFerie = descPianificazioneFerie;
	}

	/**
	 * @return the fkEsitoRichAdesionePf
	 */
	public Long getFkEsitoRichAdesionePf() {
		return this.fkEsitoRichAdesionePf;
	}

	/**
	 * @param fkEsitoRichAdesionePf to set
	 */
	public void setFkEsitoRichAdesionePf(Long fkEsitoRichAdesionePf) {
		this.fkEsitoRichAdesionePf = fkEsitoRichAdesionePf;
	}

	/**
	 * @return the fkStatoPianificFerie
	 */
	public Long getFkStatoPianificFerie() {
		return this.fkStatoPianificFerie;
	}

	/**
	 * @param fkStatoPianificFerie to set
	 */
	public void setFkStatoPianificFerie(Long fkStatoPianificFerie) {
		this.fkStatoPianificFerie = fkStatoPianificFerie;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DrichPianifFerieAmmto
	 */
	public Collection<DrichPianifFerieAmmto> getTheDrichPianifFerieAmmto() {
		return theDrichPianifFerieAmmto;
	}

	/**
	 * @param aDrichPianifFerieAmmtoList to set
	 */
	public void setTheDrichPianifFerieAmmto(Collection<DrichPianifFerieAmmto> aDrichPianifFerieAmmtoList) {
		theDrichPianifFerieAmmto = aDrichPianifFerieAmmtoList;
	}

	/**
	 * @return the DperiodiAmmtoPf
	 */
	public Collection<DperiodiAmmtoPf> getTheDperiodiAmmtoPf() {
		return theDperiodiAmmtoPf;
	}

	/**
	 * @param aDperiodiAmmtoPfList to set
	 */
	public void setTheDperiodiAmmtoPf(Collection<DperiodiAmmtoPf> aDperiodiAmmtoPfList) {
		theDperiodiAmmtoPf = aDperiodiAmmtoPfList;
	}

	/// ADD CHILD
	public void addDrichPianifFerieAmmto(DrichPianifFerieAmmto drichPianifFerieAmmto) {
		theDrichPianifFerieAmmto.add(drichPianifFerieAmmto);
	}

	public void addDperiodiAmmtoPf(DperiodiAmmtoPf dperiodiAmmtoPf) {
		theDperiodiAmmtoPf.add(dperiodiAmmtoPf);
	}

	// PARENT GETTER/SETTER
	/**
	 * @return the DstatiPianificFerie
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DstatiPianificFerie getTheDstatiPianificFerie() {
		return theDstatiPianificFerie;
	}

	/**
	 * @param aDstatiPianificFerieList to set
	 */
	public void setTheDstatiPianificFerie(DstatiPianificFerie aDstatiPianificFerie) {
		theDstatiPianificFerie = aDstatiPianificFerie;
	}

	/**
	 * @return the DesitiRichAdesionePf
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DesitiRichAdesionePf getTheDesitiRichAdesionePf() {
		return theDesitiRichAdesionePf;
	}

	/**
	 * @param aDesitiRichAdesionePfList to set
	 */
	public void setTheDesitiRichAdesionePf(DesitiRichAdesionePf aDesitiRichAdesionePf) {
		theDesitiRichAdesionePf = aDesitiRichAdesionePf;
	}

	// PARENT ID GETTER/SETTER
	/**
	 * Return the dstatiPianificFerieKey from theDstatiPianificFerie.
	 * 
	 * @return dstatiPianificFerieKey from theDstatiPianificFerie.
	 */
	@JsonProperty
	public DstatiPianificFerieKey getDstatiPianificFerieKey() {
		// If the parent entity object is null, then return null
		if (getTheDstatiPianificFerie() == null) {
			return null;
		}
		// Return requested attribute
		return theDstatiPianificFerie.getDstatiPianificFerieKey();
	}

	/**
	 * Return the desitiRichAdesionePfKey from theDesitiRichAdesionePf.
	 * 
	 * @return desitiRichAdesionePfKey from theDesitiRichAdesionePf.
	 */
	@JsonProperty
	public DesitiRichAdesionePfKey getDesitiRichAdesionePfKey() {
		// If the parent entity object is null, then return null
		if (getTheDesitiRichAdesionePf() == null) {
			return null;
		}
		// Return requested attribute
		return theDesitiRichAdesionePf.getDesitiRichAdesionePfKey();
	}

	// PARENT OBJECT TITLE
	/**
	 * Return the object title of theDstatiPianificFerie.
	 * 
	 * @return the object title of theDstatiPianificFerie.
	 */
	@JsonProperty
	public String getTheDstatiPianificFerieObjectTitle() {
		return getTheDstatiPianificFerie() != null ? getTheDstatiPianificFerie().getObjectTitle() : null;
	}

	/**
	 * Return the object title of theDesitiRichAdesionePf.
	 * 
	 * @return the object title of theDesitiRichAdesionePf.
	 */
	@JsonProperty
	public String getTheDesitiRichAdesionePfObjectTitle() {
		return getTheDesitiRichAdesionePf() != null ? getTheDesitiRichAdesionePf().getObjectTitle() : null;
	}

	// PARENT OBJECT KEY
	/**
	 * Return the object key of theDstatiPianificFerie.
	 * 
	 * @return the object key of theDstatiPianificFerie.
	 */
	@JsonProperty
	public String getTheDstatiPianificFerieObjectKey() {
		return getTheDstatiPianificFerie() != null ? getTheDstatiPianificFerie().getObjectKey() : null;
	}

	/**
	 * Set object key of theDstatiPianificFerie.
	 * 
	 */
	@JsonProperty
	public void setTheDstatiPianificFerieObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDstatiPianificFerieObjectKey(), objectKey, false)) {
			DstatiPianificFerie dstatiPianificFerie = new DstatiPianificFerie();
			dstatiPianificFerie.setObjectKey(objectKey);
			setTheDstatiPianificFerie(dstatiPianificFerie);
		}
	}

	/**
	 * Return the object key of theDesitiRichAdesionePf.
	 * 
	 * @return the object key of theDesitiRichAdesionePf.
	 */
	@JsonProperty
	public String getTheDesitiRichAdesionePfObjectKey() {
		return getTheDesitiRichAdesionePf() != null ? getTheDesitiRichAdesionePf().getObjectKey() : null;
	}

	/**
	 * Set object key of theDesitiRichAdesionePf.
	 * 
	 */
	@JsonProperty
	public void setTheDesitiRichAdesionePfObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDesitiRichAdesionePfObjectKey(), objectKey, false)) {
			DesitiRichAdesionePf desitiRichAdesionePf = new DesitiRichAdesionePf();
			desitiRichAdesionePf.setObjectKey(objectKey);
			setTheDesitiRichAdesionePf(desitiRichAdesionePf);
		}
	}

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDpianificFerieAmmtoKey());
	}

	public String getObjectKeyById(DpianificFerieAmmtoKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dpianificFerieAmmtoKey = new DpianificFerieAmmtoKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiPianificazioneFerie());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DpianificFerieAmmtoKey dpianificFerieAmmtoKey;

	// GETTER/SETTER CK
	/**
	 * @return the dpianificFerieAmmtoKey
	 */
	public DpianificFerieAmmtoKey getDpianificFerieAmmtoKey() {
		return this.dpianificFerieAmmtoKey;
	}

	/**
	 * @param dpianificFerieAmmtoKey to set
	 */
	public void setDpianificFerieAmmtoKey(DpianificFerieAmmtoKey dpianificFerieAmmtoKey) {
		this.dpianificFerieAmmtoKey = dpianificFerieAmmtoKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dpianificFerieAmmtoKey == null) {
			dpianificFerieAmmtoKey = new DpianificFerieAmmtoKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DpianificFerieAmmto that = (DpianificFerieAmmto) o;
		return dpianificFerieAmmtoKey != null && Objects.equals(dpianificFerieAmmtoKey, that.dpianificFerieAmmtoKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dpianificFerieAmmtoKey);
	}
}
